#include "msgparser.h"
#include "string.h"
#include "stdio.h"

MsgParser::MsgParser(char *b, HANDLE h, char fieldSep) :
buf(b), bufMutex(h), fs(fieldSep), active(false) {}

void MsgParser::GetMessage(char *result) {
	int numTokens = 0;
	
	if (!active) {
		WaitForSingleObject(bufMutex, INFINITE);
		strncpy(msg, buf, GAMEBUFSIZE);
		len = strlen(msg);
		if (len) {
			buf[0] = 0;
			active = true;
			pos = 0;
					
			for (int i = 0; i < len; i++)
				if (msg[i] == fs) numTokens++;
			numTokens++;
		}
		ReleaseMutex(bufMutex);
	}
	else
		numTokens = -1;

	sprintf(result, "%d", numTokens);
}

void MsgParser::NextToken(char *result) {
	int resPos = 0;
	if (active) {
		while (pos < len && msg[pos] != fs) {
			result[resPos++] = msg[pos++];
		}
		pos++;
		if (pos >= len) active = false;
	}
	result[resPos] = NULL;
}

void MsgParser::Reset() {
	active = false;
}

void MsgParser::setMutex(HANDLE h) {
	bufMutex = h;
}